//
//  ViewController.swift
//  CollectionViewAnimationsDemo
//
//  Created by Jake Marsh on 4/3/17.
//
//

import UIKit

extension UIColor {
  static func random() -> UIColor {
    let colors: [UIColor] = [.red, .blue, .green, .yellow, .purple, .orange]

    return colors[Int(arc4random()) % colors.count]
  }
}

struct Item { var color: UIColor }

class ItemCell : UICollectionViewCell { }

class SquaresViewController: UICollectionViewController {
  var items = [Item]()
  
var small: UICollectionViewFlowLayout = {
  let layout = UICollectionViewFlowLayout()
  
  layout.itemSize = CGSize(width: 75, height: 75)

  return layout
}()

var big: UICollectionViewFlowLayout = {
  let layout = UICollectionViewFlowLayout()
  
  layout.itemSize = CGSize(width: 150, height: 150)

  return layout
}()

  init() {
    super.init(collectionViewLayout: small)
  }

  required init?(coder aDecoder: NSCoder) { fatalError() }

  override func viewDidLoad() {
    super.viewDidLoad()

    items = (0...30).map { _ in Item(color: .random()) }

    collectionView?.backgroundColor = .white
    collectionView?.register(ItemCell.self, forCellWithReuseIdentifier: "ItemCell")
  }

  override func collectionView(_ collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
    return items.count
  }

  override func collectionView(_ collectionView: UICollectionView, cellForItemAt indexPath: IndexPath) -> UICollectionViewCell {
    let cell = collectionView.dequeueReusableCell(withReuseIdentifier: "ItemCell", for: indexPath)

    cell.backgroundColor = items[indexPath.item].color

    return cell
  }

  override func collectionView(_ collectionView: UICollectionView, didSelectItemAt indexPath: IndexPath) {
    let newLayout = (collectionView.collectionViewLayout == small ? big : small)

    collectionView.setCollectionViewLayout(newLayout, animated: true)
  }
}
